# Contribution Guidelines

## Ways To Contribute

There are numerous ways to contribute to [Zen Cart&reg;](https://www.zen-cart.com/):

1. Post duplicatable bug reports as Issues on github.
2. Code containing bug fixes or new features or fixing issues on github
3. Plugins as 3rd party contributions which shopowners can install to their own site
4. Snippets of bugfixes or minor tweaks to assist with solving specific questions posted on our support forum at [https://www.zen-cart.com/forum.php](https://www.zen-cart.com/forum.php)

## Guidelines
When submitting bug reports, issues, plugins, or code as pull requests, please adhere to the following guidelines:

* Please search previous suggestions before making a new one, as yours may be a duplicate.
* Each suggestion/report/pull-request should be separate. Don't mix multiple issues into one. See [Pull Request Guidelines](http://docs.zen-cart.com/Contributing/main/pull_requests)
* Code submissions should comply with the [Coding Standards](http://docs.zen-cart.com/Contributing/main/coding_standards)
* If reporting a bug/issue, please provide exact steps which one can take to recreate the bug, starting from a brand new fresh install. See [Guidelines for Reporting Bugs](http://docs.zen-cart.com/Contributing/main/issues)
* If providing a suggestion, please also explain the business problem the suggestion will solve.
* If publishing a plugin, be sure it complies with the [Plugin Contribution Guidelines](https://www.zen-cart.com/content.php?53)
* Check your spelling and grammar.

Thank you for your contributions!


&nbsp;  
  
*&copy;Copyright 2003-2015, Zen Cart&reg;. All rights reserved.*

